
/********************************/ #ifndef ARRAYLIST_T_H /*****************************/
#define ARRAYLIST_T_H

typedef struct {
	void *mem;
	int len;
	int memlen;
	size_t data_size;
} arraylist_t;


// Iz𐶐 //
arraylist_t *arraylist_create(size_t size);



// vfǉ //////////////////////////////////////
// |C^ǉ
int arraylist_add(arraylist_t *t, void *data);

// charǉ
int arraylist_char_add(arraylist_t *t, char data);

// unsigned charǉ
int arraylist_uchar_add(arraylist_t *t, unsigned char data);

// intǉ
int arraylist_int_add(arraylist_t *t, int data);

// unsigned intǉ
int arraylist_uint_add(arraylist_t *t, unsigned int data);


// vf擾 //
void *arraylist_get(arraylist_t *t, int idx);
///////////////////////////////////////////////////



// vf擾 //
int arraylist_length(arraylist_t *t);



// vfɂ //
int arraylist_clear(arraylist_t *t);



// Iz폜 //
void arraylist_release(arraylist_t *t);



/*************************************/ #endif /**********************************/
