
/*
  TonyuAlphaPNGLib ver 1.0
  
*/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <windows.h>
#include <tchar.h>
#include "png.h"
#include "pngconf.h"

#include "PngFunc.h"
#include "AlphaAnalysis.h"

#pragma comment(lib, "libpng.lib")
#pragma comment(lib, "shlwapi.lib")



int _tmain(int argc, TCHAR* argv[]) {
	
	int nRVal;
	arraylist_t *mask_data, *temp_ary;
	int i, j, size, error;
	loadPngInfo_t loadPngInfo;
	unsigned int *img_buf = NULL;
	DWORD startTime, endTime;
	TCHAR error_str[1024];
	
	printf("TonyuAlphaPNGLib ver 1.0\n\n");
	
	startTime = timeGetTime();
	
	if (argc >= 2) {
		for (i = 1; i < argc; i++) {
			error = 0;
			
			printf("%s\n", argv[i]);
			//printf(" [ %3d / %3d ]\r", i - 1, argc - 1);
			
			error_str[0] = '\0';
			
			// PNGǂݍ //
			nRVal = fileLoadPng(argv[i], &img_buf, &loadPngInfo, error_str);
			if (nRVal != 0) {
				printf("G[ : %s\n\n", error_str);
				error = 1;
				goto errorLabel;
			}
			//printf("ǂݍ݊\n");
			
			// At@[l //
			mask_data = imageAnalysis(img_buf, loadPngInfo.width, loadPngInfo.height, error_str);
			if (mask_data == NULL) {
				printf("G[ : %s\n\n", error_str);
				error = 2;
				goto errorLabel;
			}
			//printf("͊\n");
			
			// At@[f[^t@Cɏ //
			nRVal = alphaDataWriteFile(argv[i], mask_data, error_str);
			if (nRVal != 0) {
				printf("G[ : %s\n\n", error_str);
				error = 3;
			}
			
			// At@[f[^̃ //
			size = arraylist_length(mask_data);
			for (j = 0; j < size; j++) {
				temp_ary = *((arraylist_t **)(arraylist_get(mask_data, j)));
				arraylist_release(temp_ary);
			}
			arraylist_release(mask_data);
			
			
			errorLabel:
			// PNGC[W̃ //
			if (img_buf) {
				free(img_buf);
				img_buf = NULL;
			}
			
			if (error == 0) printf("ɏ܂\n\n");
		}
	} else {
		printf(
			"@At@`ltPNGt@CA\n"
			"@st@CɃhbOhbvĎg܂B\n"
			"\n"
			"A͂ɐƁAPNGt@CuĂꏊ\n"
			"@́u.talvgq̃t@C쐬܂B\n"
			"\n"
			"Btalt@CvWFNgfilestH_ɓāA\n"
			"@TonyũvOǂݍނƂŁA\n"
			"@At@摜\邱Ƃł܂B\n"
			"\n"
			"@iǂݍ݁E\ɂ͕tAlphaPat.tonyug܂j\n"
			);
		goto endLabel;
	}
	
	endLabel:
	
	endTime = timeGetTime();
	if (argc >= 2) printf(" : %.3f", ((double)(endTime - startTime) / 1000.0));
	
	printf("\n[L[ƏI܂]\n");
	getch();
	
	return 0;
}


